from scripts.parser import *
class PrioWakeLog(Log):
    def __init__(self,filename):
		Log.__init__(self,filename)

    def eval(self):
	woke, end_time, top_prio = (False, None, None)
	for line in self.read():
	    line = line[13:]
	    if woke is False:
		if (line[:6] == "Master"):
		    woke = True
		continue
	    elif line[len(line) - 5:] == "awake":
		time = line[15:22]
		prio = line[27:30]
		if (end_time is None and top_prio is None):
		    end_time = time
		    top_prio = prio
		elif (end_time > time and top_prio < prio):
		    return False
		else:
		    return True	
	return True

def main():
	if len(sys.argv) < 2:
		sys.exit("Usage : ./%s <logname>" % sys.argv[0])
	else:
		log_file=sys.argv[1]

	log = PrioWakeLog(log_file)    
	sys.exit("Result: %s " % (["FAIL", "PASS"][log.eval()]))

if __name__ == "__main__":
    main()
